unit Ugrad;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Label3: TLabel;
    Button1: TButton;
    Edit1: TEdit;
    Button3: TButton;
    Button4: TButton;
    ListBox1: TListBox;
    Button2: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    ColorDialog1: TColorDialog;
    FontDialog1: TFontDialog;
    Panel2: TPanel;
    Button8: TButton;
    Image2: TImage;
    PopupMenu1: TPopupMenu;
    Backcolor1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Copytoclipboard1: TMenuItem;
    SelectAll1: TMenuItem;
    N2: TMenuItem;
    Deletecolor1: TMenuItem;
    Modifycolor1: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    LoadGradient1: TMenuItem;
    SaveGradient1: TMenuItem;
    Button9: TButton;
    Button10: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel3: TPanel;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Design;
    procedure FormResize(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ListBox1MeasureItem(Control: TWinControl; Index: Integer;
      var Height: Integer);
    procedure Button6Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Backcolor1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button9Click(Sender: TObject);
    procedure LoadGradient;
    procedure SaveGradient;
    procedure Button10Click(Sender: TObject);
    procedure ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Modifycolor1Click(Sender: TObject);
    procedure Deletecolor1Click(Sender: TObject);
    procedure LoadGradient1Click(Sender: TObject);
    procedure SaveGradient1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure Copytoclipboard1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Memo1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure AddColor;
    procedure ModifyColor;
    procedure DeleteColor;
  private
    { Dclarations prives }
    DesignFont: TFont;
    imBkColor: TColor;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function CoulToRGB(coul: TColor): LongInt;
var l: longint;
begin
     l := 0;
     l := l + (coul and 255) shl 16; // R
     l := l + (coul and $FF00);      // G
     l := l + (coul shr 16) and 255; // B
     CoulToRGB := l;
end;

function RGBToCoul(RGB: Longint): TColor;
var l: TColor;
begin
     l := 0;
     l := l + (RGB shr 16) and 255; // B
     l := l + (RGB and $FF00);      // G
     l := l + (RGB and 255) shl 16; // R
     RGBToCoul := l;
end;

function HexToInt (hexstr: string): LongInt;
begin
     HexToInt := StrToInt ('$' + hexStr);
end;

procedure TForm1.AddColor;
var Coul: TColor;
    HexStr: String;
begin
     if ColorDialog1.Execute then
     begin
          Coul := ColorDialog1.Color;
          HexStr := IntToHex(CoulToRGB(Coul),6);
          ListBox1.Items.Add (HexStr);
          ListBox1.ItemIndex := ListBox1.Items.Count-1;
          ListBox1.Repaint;
          Design;
     end;
     ListBox1.SetFocus;
end;

function RoundM(x: real): LongInt;
begin
     RoundM := Trunc(x);
end;

function RoundP(x: real): longint;
begin
     RoundP := Round(x) + (1 - (Round(x) - Trunc(x)) );
end;

function HTMLChar(c: char): String;
var s: string;
begin
     s := '';
     if      c='' then s := '<br>'
     else if c='"' then s := '&quot;'
     else if c=' ' then s := '&nbsp;'
     else if c='<' then s := '&lt;'
     else if c='&' then s := '&amp;'
     else if c='' then s := '&agrave;'
     else if c='' then s := '&egrave;'
     else if c='' then s := '&ugrave;'
     else if c='' then s := '&eacute;'
     else if c='' then s := '&acirc;'
     else if c='' then s := '&ecirc;'
     else if c='' then s := '&icirc;'
     else if c='' then s := '&ocirc;'
     else if c='' then s := '&ucirc;'
     else if c='' then s := '&auml;'
     else if c='' then s := '&euml;'
     else if c='' then s := '&iuml;'
     else if c='' then s := '&ouml;'
     else if c='' then s := '&uuml;'
     else if c='' then s := '&yuml;'
     else s := c;
     HTMLChar := s;
end;

function Coul2HTML (red, green, blue: integer): String;
var s: string;
begin
     s := '#';
     s := s + IntToHex(red,2);
     s := s + IntToHex(green,2);
     s := s + IntToHex(blue,2);
     Coul2HTML := s;
end;

Function Sign(nb: integer): integer;
begin
     Sign := Trunc(nb / Abs(nb));
end;

function GetHSize(size: integer; b: boolean): string;
var s: string;
begin
     if b then s := '<h' else s := '</h';
     if size<19 then
        s := s + intToStr ((20-size) div 2) + '>';
     if ( (size>18) and (size<22) ) then
        s := s + '2>';
     if (size>21) then
        s := s + '1>';
     GetHSize := s;
end;

function GetRed(HexStr: string): integer;
begin
     GetRed := HexToInt(Copy(HexStr,1,2));
end;

function GetGreen(HexStr: string): integer;
begin
     GetGreen := HexToInt(Copy(HexStr,3,2));
end;

function GetBlue(HexStr: string): integer;
begin
     GetBlue := HexToInt(Copy(HexStr,5,2));
end;

procedure TForm1.Design;
var i,nb: integer;
    sc,ec: TColor;
    sr,sg,sb: integer;
    er,eg,eb: integer;
    ir,ig,ib: integer;
    s: string;
    under, italic, bold: boolean;
    nbColors : integer;
    ind: extended;
begin
     Memo1.Clear;
     Image1.Canvas.Brush.Color := ImBkColor;
     Image1.Canvas.Pen.Color := clWhite;
     Image1.Canvas.FillRect(Image1.Canvas.ClipRect);
     nb := Length(Edit1.Text);
     nbColors := ListBox1.Items.Count;
     if nbColors<1 then
     begin
          Application.MessageBox ('There is no color in the list!','error',id_ok);
          exit;
     end;

     Image1.Canvas.Font := DesignFont;
     Image1.Canvas.MoveTo (0,0);

     s := '<FONT face="' + DesignFont.Name + '">';
     Memo1.Lines.Add (s);
     bold := (fsBold in DesignFont.Style);
     italic := (fsItalic in DesignFont.Style);
     under := (fsUnderLine in DesignFont.Style);
     Memo1.Lines.Add (GetHSize (DesignFont.Size, True));
     if bold then
        Memo1.Lines.Add ('<i>');
     if italic then
        Memo1.Lines.Add ('<b>');
     if under then
        Memo1.Lines.Add ('<u>');

//**********************************//
     for i := 0 to (nb-1) do
     begin
          ind := i*(NbColors-1)/(nb-1);
          if (int(ind)=ind) then
          begin
               sc := HexToInt(ListBox1.Items[Round(ind)]);
               ir := (sc and $FF0000) shr 16;
               ig := (sc and $00FF00) shr 8;
               ib := (sc and $0000FF);
          end
          else
          begin
               sc := HexToInt(ListBox1.Items[RoundM(ind)]);
               ec := HexToInt(ListBox1.Items[RoundP(ind)]);
               sr := (sc and $FF0000) shr 16;
               sg := (sc and $00FF00) shr 8;
               sb := (sc and $0000FF);
               er := (ec and $FF0000) shr 16;
               eg := (ec and $00FF00) shr 8;
               eb := (ec and $0000FF);

               ir := sr + Round(frac(ind)*(er-sr));
               ig := sg + Round(frac(ind)*(eg-sg));
               ib := sb + Round(frac(ind)*(eb-sb));
          end;

          Image1.Canvas.Font.Color := ir+(ig shl 8)+(ib shl 16);
          if Edit1.Text[i+1]<>'' then
             Image1.Canvas.TextOut (Image1.Canvas.PenPos.X,
                                    Image1.Canvas.PenPos.Y,
                                    Edit1.Text[i+1])
          else
              Image1.Canvas.MoveTo (0,Image1.Canvas.PenPos.Y+
                                      Image1.Canvas.TextHeight('Mg')+2);

          s := '';
          s := '<FONT COLOR="';
          s := s + Coul2HTML(ir,ig,ib);
          s := s + '">';
          s := s + HTMLChar(Edit1.Text[i+1]);
          s := s + '</FONT>';
          Memo1.Text := Memo1.Text+s ;




     end;
//**********************************//
     if under then
        Memo1.Lines.Add ('</u>');
     if italic then
        Memo1.Lines.Add ('</b>');
     if bold then
        Memo1.Lines.Add ('</i>');

     Memo1.Lines.Add (GetHSize (DesignFont.Size, False));
     Memo1.Lines.Add ('</FONT>');


end;


procedure TForm1.ModifyColor;
var Coul: TColor;
    HexStr: String;
    i: integer;
    bsel: Boolean;
begin
     bsel := false;
     i := 0;
     repeat
           bsel := ListBox1.Selected[i];
           inc(i);
     until bsel or (i>=ListBox1.Items.Count);
     dec(i);
     if bsel and ColorDialog1.Execute then
     begin
          Coul := ColorDialog1.Color;
          HexStr := IntToHex(CoulToRGB(Coul),6);
          ListBox1.Items.Strings[i] := HexStr;
          ListBox1.Repaint;
          Design;
     end
     else Application.MessageBox ('There is no color selected','error',idok);
     ListBox1.SetFocus;
end;

procedure TForm1.DeleteColor;
var i: integer;
    bsel: boolean;
begin
     i := 0;
     bsel := false;
     repeat
           bsel := ListBox1.Selected[i];
           inc(i);
     until bsel or (i>=ListBox1.Items.Count);
     dec(i);
     if bsel then
     begin
          ListBox1.Items.Delete(i);
          ListBox1.ItemIndex := i-1;
          Design;
     end
     else
         Application.MessageBox ('There is no color selected','error',idok);
     ListBox1.SetFocus;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     AddColor;
end;



procedure TForm1.Button3Click(Sender: TObject);
begin
     if ListBox1.Items.Count>1 then
        Design
     else
         Application.MessageBox ('I need at least 2 colors to make a gradient!!!','error',idok);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
     Panel2.Top := 195;
     Edit1.Width := Panel1.Width - 96;
//     Image1.Picture.Graphic.Width := Panel3.ClientWidth;
//     Image1.Picture.Graphic.Height := Panel3.ClientHeight;
//     Image1.Canvas.StretchDraw (Image1.ClientRect, Image1.Picture.Graphic);
     Design;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
     if FontDialog1.Execute then
     begin
          DesignFont := FontDialog1.Font;
          Design;
     end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     DesignFont := Form1.Font;
     imBkColor := clWhite;
     ListBox1.items.Add ('0000FF');
     ListBox1.items.Add ('00FF00');
     ListBox1.items.Add ('FF0000');
end;


procedure TForm1.DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
  with ListBox1.Canvas do
  begin
    Pen.Color := clBlack;
    Brush.Color := RGBToCoul ( StrToInt ('$' + ListBox1.Items[index]) );
    FillRect(Rect);
//    Font := DesignFont;
    Font.Color := ($00FFFFFF xor (RGBToCoul ( HexToInt(ListBox1.Items[index]))) and $00FFFFFF);
    TextOut(Rect.Left+1, Rect.Top+1, ListBox1.Items[Index]);
  end;

end;

procedure TForm1.ListBox1MeasureItem(Control: TWinControl; Index: Integer;
  var Height: Integer);
begin
  with ListBox1.Canvas do
  begin
//    Font := DesignFont;
    Height := TextHeight('Wg') + 2; // measure ascenders and descenders
  end;

end;

procedure TForm1.Button6Click(Sender: TObject);
begin
     DeleteColor;
end;

procedure TForm1.Button2Click(Sender: TObject);
var SelNo: integer;
    bsel: boolean;
begin
     SelNo := 0;
     bsel := false;
     repeat
           bsel := ListBox1.Selected[SelNo];
           inc(SelNo);
     until bsel or (SelNo>=ListBox1.Items.Count);
     dec (SelNo);
     if bsel and (SelNo>0) then
     begin
          ListBox1.Items.BeginUpdate;
          ListBox1.Items.Exchange(SelNo, SelNo-1);
          ListBox1.Items.EndUpdate;
          ListBox1.Repaint;
          ListBox1.ItemIndex := SelNo-1;
          Design;
     end
     else if not bsel then Application.MessageBox ('There is no color selected','error',idok);
     ListBox1.SetFocus;
end;

procedure TForm1.Button5Click(Sender: TObject);
var SelNo: integer;
    bsel: boolean;
begin
     SelNo := 0;
     bsel := false;
     repeat
           bsel := ListBox1.Selected[SelNo];
           inc(SelNo);
     until bsel or (SelNo>=ListBox1.Items.Count);
     dec (SelNo);
     if bsel and (SelNo<(ListBox1.Items.Count-1)) then
     begin
          ListBox1.Items.BeginUpdate;
          ListBox1.Items.Exchange(SelNo, SelNo+1);
          ListBox1.Items.EndUpdate;
          ListBox1.ItemIndex := SelNo+1;
          ListBox1.Repaint;
          Design;
     end
     else if not bsel then Application.MessageBox ('There is no color selected','error',idok);
     ListBox1.SetFocus;

end;

procedure TForm1.Button7Click(Sender: TObject);
begin
     ModifyColor;
end;


procedure TForm1.Button8Click(Sender: TObject);
var i,j: integer;
begin
     for i := 0 to (ListBox1.Items.Count-1) div 2 do
     begin
          j := ListBox1.Items.Count - 1 - i;
          if i<j then ListBox1.Items.Exchange (i, j);
     end;
     Design;
end;

procedure TForm1.Backcolor1Click(Sender: TObject);
begin
     if ColorDialog1.Execute then
     begin
          imBkColor := ColorDialog1.Color;
          Design;
     end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
     Application.Terminate;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     ModifyColor1.Enabled := false;
     DeleteColor1.Enabled := false;
     LoadGradient1.Enabled := false;
     SaveGradient1.Enabled := false;
     CopyToClipBoard1.Enabled := false;
     SelectAll1.Enabled := false;
     BackColor1.Enabled := false;
end;

procedure TForm1.LoadGradient;
begin
     if OpenDialog1.Execute then
     begin
          ListBox1.Items.LoadFromFile(OpenDialog1.FileName);
          Design;
     end;
end;

procedure TForm1.SaveGradient;
begin
     if SaveDialog1.Execute then
     begin
          ListBox1.Items.SaveToFile(SaveDialog1.FileName);
          Design;
     end;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
     LoadGradient;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
     SaveGradient;
end;

procedure TForm1.ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     ModifyColor1.Enabled := true;
     DeleteColor1.Enabled := true;
     LoadGradient1.Enabled := true;
     SaveGradient1.Enabled := true;
     CopyToClipBoard1.Enabled := false;
     SelectAll1.Enabled := false;
     BackColor1.Enabled := false;
end;

procedure TForm1.Modifycolor1Click(Sender: TObject);
begin
     ModifyColor;
end;

procedure TForm1.Deletecolor1Click(Sender: TObject);
begin
     DeleteColor;
end;

procedure TForm1.LoadGradient1Click(Sender: TObject);
begin
     LoadGradient;
end;

procedure TForm1.SaveGradient1Click(Sender: TObject);
begin
     SaveGradient;
end;

procedure TForm1.SelectAll1Click(Sender: TObject);
begin
     Memo1.SelectAll;
end;

procedure TForm1.Copytoclipboard1Click(Sender: TObject);
begin
     Memo1.CopyToClipboard;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     ModifyColor1.Enabled := false;
     DeleteColor1.Enabled := false;
     LoadGradient1.Enabled := false;
     SaveGradient1.Enabled := false;
     CopyToClipBoard1.Enabled := false;
     SelectAll1.Enabled := false;
     BackColor1.Enabled := true;

end;

procedure TForm1.Memo1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     ModifyColor1.Enabled := false;
     DeleteColor1.Enabled := false;
     LoadGradient1.Enabled := false;
     SaveGradient1.Enabled := false;
     CopyToClipBoard1.Enabled := true;
     SelectAll1.Enabled := true;
     BackColor1.Enabled := false;

end;

end.
